---
policy: /ce/ca/google/storage/bucket-cost-effective-region
logic: /ce/ca/google/storage/bucket-cost-effective-region/prod.logic.yaml
executionTime: 2025-10-01T12:51:20.05244505Z
generationMs: 66
executionMs: 713
rows:
  - id: '001'
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: '002'
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 899
      actual: 899
    conditionText:
      expected: extract('CA10__location__c') == 'europe-west2'
      actual: extract('CA10__location__c') == 'europe-west2'
    runtimeError: {}
  - id: '003'
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 1400
      actual: 1400
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/google/storage/bucket-cost-effective-region/policy.yaml
    md5Hash: 03E3F068C4B5BD54C95C74A2457FA1AC
    content: |
      ---
      names:
        full: "Google Storage Bucket is located in a less cost-effective region"
        contextual: "Bucket is located in a less cost-effective region"
      description: "This policy flags Storage Buckets that are running in Google regions\
        \ with higher pricing and could potentially be migrated to more cost-effective regions."
      type: "BEST_PRACTICE"
      categories:
        - "COST"
      frameworkMappings:
        - "/frameworks/cloudaware/cost-efficiency-and-optimization/resource-optimization"
  - path: /ce/ca/google/storage/bucket-cost-effective-region/prod.logic.yaml
    md5Hash: 2D0F4DE42AF13D9C10B9733605CF1034
    content: |
      ---
      inputType: "CA10__CaGoogleStorageBucket__c"
      importExtracts:
        - file: "/types/CA10__CaGoogleStorageBucket__c/object.extracts.yaml"
      testData:
        - file: 'test-data.json'
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in us-west2 which is more expensive than us-west1."
          remediationMessage: "Consider migrating the Bucket to us-west1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "us-west2"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in us-west3 which is more expensive than us-west1."
          remediationMessage: "Consider migrating the Bucket to us-west1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "us-west3"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in us-west4 which is more expensive than us-west1."
          remediationMessage: "Consider migrating the Bucket to us-west1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "us-west4"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in northamerica-northeast1 which is more expensive than us-east1, us-east5 or us-central1."
          remediationMessage: "Consider migrating the Bucket to us-east1, us-east5 or us-central1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "northamerica-northeast1"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in northamerica-northeast2 which is more expensive than us-east1, us-east5 or us-central1."
          remediationMessage: "Consider migrating the Bucket to us-east1, us-east5 or us-central1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "northamerica-northeast2"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-southwest1 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-southwest1"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west12 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west12"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west2 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west2"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west3 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west3"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west6 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west6"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west8 which is more expensive than europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west8"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-west9 which is more expensive europe-west4."
          remediationMessage: "Consider migrating the Bucket to europe-west4."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-west9"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Bucket is running in europe-north2 which is more expensive than europe-north1 or europe-west1."
          remediationMessage: "Consider migrating the Bucket to europe-north1 or europe-west1."
          check:
            IS_EQUAL:
              left:
                EXTRACT: CA10__location__c
              right:
                TEXT: "europe-north2"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "The Bucket is located in a cost-effective region."
  - path: /ce/ca/google/storage/bucket-cost-effective-region/test-data.json
    md5Hash: 9937E76F08AF2FA12B82106C40FEE911
    content: |
      [
        {
          "expectedResult": {
            "status": "DISAPPEARED",
            "conditionIndex": "99",
            "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-09-25T19:57:41Z" },
          "Id": "001",
          "CA10__disappearanceTime__c": "2024-06-16T09:12:21Z",
          "CA10__location__c": "EU"
        },
        {
          "expectedResult": {
            "status": "INCOMPLIANT",
            "conditionIndex": "899",
            "conditionText": "extract('CA10__location__c') == 'europe-west2'",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-09-25T19:57:41Z" },
          "Id": "002",
          "CA10__disappearanceTime__c": null,
          "CA10__location__c": "EUROPE-WEST2"
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "1400",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-09-25T19:57:41Z" },
          "Id": "003",
          "CA10__disappearanceTime__c": null,
          "CA10__location__c": "US"
        }
      ]
  - path: /types/CA10__CaGoogleStorageBucket__c/object.extracts.yaml
    md5Hash: ED1FDC8BD3DB0862B4D9A76164FC9744
    content: "---\nextracts:\n  - name: \"CA10__levelAccessState__c\"\n    value:\
      \ \n      FIELD:\n        path: \"CA10__levelAccessState__c\"\n  - name: \"\
      CA10__retentionPolicyLock__c\"\n    value: \n      FIELD:\n        path: \"\
      CA10__retentionPolicyLock__c\"\n# Text\n  - name: \"CA10__location__c\"\n  \
      \  value: \n      FIELD:\n        path: \"CA10__location__c\"\n        "
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "001",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "002",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "899",
      "conditionText" : "extract('CA10__location__c') == 'europe-west2'",
      "runtimeError" : null
    }
  }, {
    "Id" : "003",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "1400",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaGoogleStorageBucket__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__location__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-09-25T19:57:41Z")
    },
    "Id" : "001",
    "CA10__disappearanceTime__c" : new Date("2024-06-16T09:12:21Z"),
    "CA10__location__c" : "EU"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-09-25T19:57:41Z")
    },
    "Id" : "002",
    "CA10__location__c" : "EUROPE-WEST2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-09-25T19:57:41Z")
    },
    "Id" : "003",
    "CA10__location__c" : "US"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaGoogleStorageBucket__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__location__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
          this.containsAll = function(arg, substrings) {
              if (substrings == null || substrings.length === 0) return false;
              let normalizedArg = this.normalize(arg);
              return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
          };
          this.containsAny = function(arg, substrings) {
              if (substrings == null || substrings.length === 0) return false;
              let normalizedArg = this.normalize(arg);
              return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Google [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      references1.push('Location [obj.CA10__location__c]: ' + obj.CA10__location__c);
      if (TextLib.equal(extract3.call(extract3), 'us-west2')) {
          return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__location__c') == 'us-west2'", currentStateMessage: "The Bucket is running in us-west2 which is more expensive than us-west1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to us-west1.", runtimeError: null};
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract6.call(extract6), 'us-west3')) {
          return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__location__c') == 'us-west3'", currentStateMessage: "The Bucket is running in us-west3 which is more expensive than us-west1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to us-west1.", runtimeError: null};
      }
      // condition[3], conditionIndex:[300..399]
      function extract9() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract9.call(extract9), 'us-west4')) {
          return {status: 'INCOMPLIANT', conditionIndex: 399, conditionText: "extract('CA10__location__c') == 'us-west4'", currentStateMessage: "The Bucket is running in us-west4 which is more expensive than us-west1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to us-west1.", runtimeError: null};
      }
      // condition[4], conditionIndex:[400..499]
      function extract12() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract12.call(extract12), 'northamerica-northeast1')) {
          return {status: 'INCOMPLIANT', conditionIndex: 499, conditionText: "extract('CA10__location__c') == 'northamerica-northeast1'", currentStateMessage: "The Bucket is running in northamerica-northeast1 which is more expensive than us-east1, us-east5 or us-central1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to us-east1, us-east5 or us-central1.", runtimeError: null};
      }
      // condition[5], conditionIndex:[500..599]
      function extract15() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract15.call(extract15), 'northamerica-northeast2')) {
          return {status: 'INCOMPLIANT', conditionIndex: 599, conditionText: "extract('CA10__location__c') == 'northamerica-northeast2'", currentStateMessage: "The Bucket is running in northamerica-northeast2 which is more expensive than us-east1, us-east5 or us-central1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to us-east1, us-east5 or us-central1.", runtimeError: null};
      }
      // condition[6], conditionIndex:[600..699]
      function extract18() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract18.call(extract18), 'europe-southwest1')) {
          return {status: 'INCOMPLIANT', conditionIndex: 699, conditionText: "extract('CA10__location__c') == 'europe-southwest1'", currentStateMessage: "The Bucket is running in europe-southwest1 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[7], conditionIndex:[700..799]
      function extract21() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract21.call(extract21), 'europe-west12')) {
          return {status: 'INCOMPLIANT', conditionIndex: 799, conditionText: "extract('CA10__location__c') == 'europe-west12'", currentStateMessage: "The Bucket is running in europe-west12 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[8], conditionIndex:[800..899]
      function extract24() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract24.call(extract24), 'europe-west2')) {
          return {status: 'INCOMPLIANT', conditionIndex: 899, conditionText: "extract('CA10__location__c') == 'europe-west2'", currentStateMessage: "The Bucket is running in europe-west2 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[9], conditionIndex:[900..999]
      function extract27() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract27.call(extract27), 'europe-west3')) {
          return {status: 'INCOMPLIANT', conditionIndex: 999, conditionText: "extract('CA10__location__c') == 'europe-west3'", currentStateMessage: "The Bucket is running in europe-west3 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[10], conditionIndex:[1000..1099]
      function extract30() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract30.call(extract30), 'europe-west6')) {
          return {status: 'INCOMPLIANT', conditionIndex: 1099, conditionText: "extract('CA10__location__c') == 'europe-west6'", currentStateMessage: "The Bucket is running in europe-west6 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[11], conditionIndex:[1100..1199]
      function extract33() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract33.call(extract33), 'europe-west8')) {
          return {status: 'INCOMPLIANT', conditionIndex: 1199, conditionText: "extract('CA10__location__c') == 'europe-west8'", currentStateMessage: "The Bucket is running in europe-west8 which is more expensive than europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[12], conditionIndex:[1200..1299]
      function extract36() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract36.call(extract36), 'europe-west9')) {
          return {status: 'INCOMPLIANT', conditionIndex: 1299, conditionText: "extract('CA10__location__c') == 'europe-west9'", currentStateMessage: "The Bucket is running in europe-west9 which is more expensive europe-west4.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-west4.", runtimeError: null};
      }
      // condition[13], conditionIndex:[1300..1399]
      function extract39() { if (!this.out) { this.out = obj.CA10__location__c; } return this.out; };
      if (TextLib.equal(extract39.call(extract39), 'europe-north2')) {
          return {status: 'INCOMPLIANT', conditionIndex: 1399, conditionText: "extract('CA10__location__c') == 'europe-north2'", currentStateMessage: "The Bucket is running in europe-north2 which is more expensive than europe-north1 or europe-west1.", currentStateReferences: references1.join('\n'), remediation: "Consider migrating the Bucket to europe-north1 or europe-west1.", runtimeError: null};
      }
      return {status: 'COMPLIANT', conditionIndex: 1400, conditionText: "otherwise", currentStateMessage: "The Bucket is located in a cost-effective region.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__location__c AS CA10__location__c,
          process_CA10__CaGoogleStorageBucket__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__location__c AS CA10__location__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaGoogleStorageBucket__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
